#include "stdafx.h"

#include "Drawtools.h"

CDrawTools::CDrawTools()
{
	m_LineThick = 1;
}

CDrawTools::~CDrawTools()
{

}

void CDrawTools::SetLineThick(int LineThick)
{
	m_LineThick = LineThick;
}

void CDrawTools::DrawLine(CDC *pDC,int nSx,int nSy,int nEx,int nEy,COLORREF nColor)
{
	CPen Pen, *pOldPen;

	Pen.CreatePen(PS_SOLID,m_LineThick,nColor);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->MoveTo(nSx,nSy);
	pDC->LineTo(nEx,nEy);

	pDC->SelectObject(pOldPen);
	Pen.DeleteObject();
}


void CDrawTools::DrawLine(CDC *pDC,RECT Rect,COLORREF Color)
{
	DrawLine(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color);
}


void CDrawTools::DrawLine(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,COLORREF nColor)
{
	CClientDC dc(pWnd);

	DrawLine(&dc,nSx,nSy,nEx,nEy,nColor);
}

void CDrawTools::DrawLine(CWnd *pWnd,RECT Rect,COLORREF Color)
{
	CClientDC dc(pWnd);

	DrawLine(&dc,Rect,Color);
}


void CDrawTools::DrawRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color)
{
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

	Pen.CreatePen(PS_SOLID,m_LineThick,Color);
	Brush.CreateStockObject(NULL_BRUSH);

	pOldBrush = (CBrush*)pDC->SelectObject(&Brush);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->Rectangle(nSx,nSy,nEx,nEy);

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	Brush.DeleteObject();
	Pen.DeleteObject();
}

void CDrawTools::DrawRect(HDC hdc,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	HPEN hPen, hOldPen;
	HBRUSH hBrush, hOldBrush;

	if(Color1==Color2){
		hPen = CreatePen(PS_NULL,1,Color1);
		nEx++, nEy++;
	}
	else{
		hPen = CreatePen(PS_SOLID,m_LineThick,Color1);
	}
	hBrush = CreateSolidBrush(Color2);

	hOldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	hOldPen = (HPEN)SelectObject(hdc, hPen);

	Rectangle(hdc, nSx,nSy,nEx,nEy);

	SelectObject(hdc, hOldBrush);
	SelectObject(hdc, hOldPen);

	DeleteObject(hBrush);
	DeleteObject(hPen);
}

void CDrawTools::DrawRect(HDC hdc,RECT Rect,long Color1,long Color2)
{
	DrawRect(hdc,Rect.left,Rect.top,Rect.right,Rect.bottom,Color1, Color2);
}

void CDrawTools::DrawRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	DrawRect(pDC->m_hDC, nSx, nSy, nEx, nEy, Color1, Color2);
}


void CDrawTools::DrawRect(CDC *pDC,RECT Rect,long Color)
{
	DrawRect(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color);
}

void CDrawTools::DrawRect(CDC *pDC,RECT Rect,long Color1,long Color2)
{
	DrawRect(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color1,Color2);
}

void CDrawTools::DrawRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color)
{
	CClientDC dc(pWnd);

	DrawRect(&dc,nSx,nSy,nEx,nEy,Color);
}

void CDrawTools::DrawRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	CClientDC dc(pWnd);

	DrawRect(&dc,nSx,nSy,nEx,nEy,Color1,Color2);
}

void CDrawTools::DrawRect(CWnd *pWnd,RECT Rect,long Color)
{
	CClientDC dc(pWnd);

	DrawRect(&dc,Rect,Color);
}

void CDrawTools::DrawRect(CWnd *pWnd,RECT Rect,long Color1,long Color2)
{
	CClientDC dc(pWnd);

	DrawRect(&dc,Rect,Color1,Color2);
}

void CDrawTools::DrawEllipse(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color)
{
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

	Pen.CreatePen(PS_SOLID,m_LineThick,Color);
	Brush.CreateStockObject(NULL_BRUSH);

	pOldBrush = (CBrush*)pDC->SelectObject(&Brush);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->Ellipse(nSx,nSy,nEx,nEy);

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	Brush.DeleteObject();
	Pen.DeleteObject();
}

void CDrawTools::DrawEllipse(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

	Pen.CreatePen(PS_SOLID,m_LineThick,Color1);
	Brush.CreateSolidBrush(Color2);

	pOldBrush = (CBrush*)pDC->SelectObject(&Brush);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->Ellipse(nSx,nSy,nEx,nEy);

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	Brush.DeleteObject();
	Pen.DeleteObject();
}

void CDrawTools::DrawEllipse(CDC *pDC,RECT Rect,long Color)
{
	DrawEllipse(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color);
}

void CDrawTools::DrawEllipse(CDC *pDC,RECT Rect,long Color1,long Color2)
{
	DrawEllipse(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color1,Color2);
}

void CDrawTools::DrawEllipse(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color)
{
	CClientDC dc(pWnd);

	DrawEllipse(&dc,nSx,nSy,nEx,nEy,Color);
}

void CDrawTools::DrawEllipse(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	CClientDC dc(pWnd);

	DrawEllipse(&dc,nSx,nSy,nEx,nEy,Color1,Color2);
}

void CDrawTools::DrawEllipse(CWnd *pWnd,RECT Rect,long Color)
{
	CClientDC dc(pWnd);

	DrawEllipse(&dc,Rect,Color);
}

void CDrawTools::DrawEllipse(CWnd *pWnd,RECT Rect,long Color1,long Color2)
{
	CClientDC dc(pWnd);

	DrawEllipse(&dc,Rect,Color1,Color2);
}

void CDrawTools::DrawRoundRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color)
{
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

	Pen.CreatePen(PS_SOLID,m_LineThick,Color);
	Brush.CreateStockObject(NULL_BRUSH);

	pOldBrush = (CBrush*)pDC->SelectObject(&Brush);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->RoundRect(nSx, nSy, nEx, nEy, (nEx-nSx)/5, (nEy-nSy)/5);

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	Brush.DeleteObject();
	Pen.DeleteObject();
}

void CDrawTools::DrawRoundRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

	Pen.CreatePen(PS_SOLID,m_LineThick,Color1);
	Brush.CreateSolidBrush(Color2);

	pOldBrush = (CBrush*)pDC->SelectObject(&Brush);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->RoundRect(nSx, nSy, nEx, nEy, (nEx-nSx)/5, (nEy-nSy)/5);

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	Brush.DeleteObject();
	Pen.DeleteObject();
}

void CDrawTools::DrawRoundRect(CDC *pDC,RECT Rect,long Color)
{
	DrawRoundRect(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color);
}

void CDrawTools::DrawRoundRect(CDC *pDC,RECT Rect,long Color1,long Color2)
{
	DrawRoundRect(pDC,Rect.left,Rect.top,Rect.right,Rect.bottom,Color1,Color2);
}

void CDrawTools::DrawRoundRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color)
{
	CClientDC dc(pWnd);

	DrawRoundRect(&dc,nSx,nSy,nEx,nEy,Color);
}

void CDrawTools::DrawRoundRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2)
{
	CClientDC dc(pWnd);

	DrawRoundRect(&dc,nSx,nSy,nEx,nEy,Color1,Color2);
}

void CDrawTools::DrawRoundRect(CWnd *pWnd,RECT Rect,long Color)
{
	CClientDC dc(pWnd);

	DrawRoundRect(&dc,Rect,Color);
}

void CDrawTools::DrawRoundRect(CWnd *pWnd,RECT Rect,long Color1,long Color2)
{
	CClientDC dc(pWnd);

	DrawRoundRect(&dc,Rect,Color1,Color2);
}

void CDrawTools::DrawPolygon(CDC *pDC, POINT *pPoints, int nCount, long Color1,long Color2)
{
	CPen Pen, *pOldPen;
	CBrush Brush, *pOldBrush;

	if(Color1==Color2){
		Pen.CreatePen(PS_NULL,1,Color1);
	}
	else{
		Pen.CreatePen(PS_SOLID,m_LineThick,Color1);
	}
	Brush.CreateSolidBrush(Color2);

	pOldBrush = (CBrush*)pDC->SelectObject(&Brush);
	pOldPen = (CPen*)pDC->SelectObject(&Pen);

	pDC->Polygon(pPoints, nCount);

	pDC->SelectObject(pOldBrush);
	pDC->SelectObject(pOldPen);

	Brush.DeleteObject();
	Pen.DeleteObject();
}

void CDrawTools::DrawTriangle(CDC *pDC, RECT Rect, int nType, long Color1, long Color2)
{
	POINT pPoint[3];
	CRect rectPos = Rect;
	CPoint point = rectPos.CenterPoint();
	memset(pPoint, 0, sizeof(POINT) * 3);
	switch(nType){
		case TYPE_TOP_POINT:
			pPoint[0].x = point.x;
			pPoint[0].y = rectPos.top;
			pPoint[1].x = rectPos.left;
			pPoint[1].y = rectPos.bottom;
			pPoint[2].x = rectPos.right;
			pPoint[2].y = rectPos.bottom;
			break;

		case TYPE_BOTTOM_POINT:
			pPoint[0].x = point.x;
			pPoint[0].y = rectPos.bottom;
			pPoint[1].x = rectPos.left;
			pPoint[1].y = rectPos.top;
			pPoint[2].x = rectPos.right;
			pPoint[2].y = rectPos.top;
			break;

		case TYPE_LEFT_POINT:
			pPoint[0].x = rectPos.left;
			pPoint[0].y = point.y;
			pPoint[1].x = rectPos.right;
			pPoint[1].y = rectPos.top;
			pPoint[2].x = rectPos.right;
			pPoint[2].y = rectPos.bottom;
			break;

		case TYPE_RIGHT_POINT:
			pPoint[0].x = rectPos.right;
			pPoint[0].y = point.y;
			pPoint[1].x = rectPos.left;
			pPoint[1].y = rectPos.top;
			pPoint[2].x = rectPos.left;
			pPoint[2].y = rectPos.bottom;
			break;
	}
	DrawPolygon(pDC, pPoint, 3, Color1, Color2);
}

void CDrawTools::DrawRectXor(CWnd *pWnd,RECT Rect)
{
	CClientDC dc(pWnd);

	dc.SetROP2(R2_XORPEN);

	DrawRect(&dc,Rect.left,Rect.top,Rect.right,Rect.bottom,RGB(255,255,255));
}


void CDrawTools::DrawRectXor(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy)
{
	CClientDC dc(pWnd);

	dc.SetROP2(R2_XORPEN);

	DrawRect(&dc,nSx,nSy,nEx,nEy,RGB(255,255,255));
}

void CDrawTools::DrawPopBox(HDC hdc, int x1, int y1, int x2, int y2, long color)
{
	HPEN hPenBlack, hPenWhite, hPenDarkGray, hOldPen;

	DrawRect(hdc, x1+1, y1+1, x2-1, y2-1, color,color);

	//Draw PopBox Frame
	hPenBlack = CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	hPenWhite = CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	hPenDarkGray = CreatePen(PS_SOLID, 1, RGB(127, 127, 127));

	hOldPen = (HPEN)SelectObject(hdc, hPenWhite);
	MoveToEx(hdc, x1+1, y2-1, NULL);
	LineTo(hdc, x1+1, y1+1);
	LineTo(hdc, x2-1, y1+1);

	SelectObject(hdc, hPenDarkGray);
	LineTo(hdc, x2-1, y2-1);
	LineTo(hdc, x1+1, y2-1);

	SelectObject(hdc, hPenWhite);
	MoveToEx(hdc, x1+2, y2-2, NULL);
	LineTo(hdc, x1+2, y1+2);
	LineTo(hdc, x2-2, y1+2);

	SelectObject(hdc, hPenDarkGray);
	LineTo(hdc, x2-2, y2-2);
	LineTo(hdc, x1+2, y2-2);

	SelectObject(hdc, hPenBlack);
	MoveToEx(hdc, x1, y1, NULL);
	LineTo(hdc, x2, y1);
	LineTo(hdc, x2, y2);
	LineTo(hdc, x1, y2);
	LineTo(hdc, x1, y1);

	SelectObject(hdc, hOldPen);
	DeleteObject(hPenBlack);
	DeleteObject(hPenWhite);
	DeleteObject(hPenDarkGray);
}

void CDrawTools::DrawPopBox(HDC hdc, RECT Rect, long Color)
{
	DrawPopBox(hdc, Rect.left, Rect.top, Rect.right, Rect.bottom, Color);
}

void CDrawTools::DrawPopBox(CDC *pDC, int x1, int y1, int x2, int y2, long color)
{
	DrawPopBox(pDC->m_hDC, x1, y1, x2, y2, color);
}

void CDrawTools::DrawPopBox(CDC *pDC,RECT Rect,long Color)
{
	DrawPopBox(pDC->m_hDC, Rect.left, Rect.top, Rect.right, Rect.bottom, Color);
}


void CDrawTools::DrawPopBox(CWnd *pWnd, int nSx, int nSy, int nEx, int nEy, long Color)
{
	CClientDC dc(pWnd);

	DrawPopBox(&dc, nSx, nSy, nEx, nEy, Color);
}

void CDrawTools::DrawPopBox(CWnd *pWnd, RECT Rect, long Color)
{
	CClientDC dc(pWnd);

	DrawPopBox(&dc, Rect, Color);
}


void CDrawTools::DrawPopBoxSmall(CDC *pDC, int x1, int y1, int x2, int y2, long color)
{
	CPen PenBlack, PenWhite, PenDarkGray, *pOldPen;

	DrawRect(pDC, x1+1, y1+1, x2-1, y2-1, color,color);

	PenBlack.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	PenWhite.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	PenDarkGray.CreatePen(PS_SOLID, 1, RGB(127, 127, 127));

	pOldPen = (CPen*)pDC->SelectObject(&PenWhite);
	pDC->MoveTo(x1+1, y2-1);
	pDC->LineTo(x1+1, y1+1);
	pDC->LineTo(x2-1, y1+1);

	pDC->SelectObject(&PenDarkGray);
	pDC->LineTo(x2-1, y2-1);
	pDC->LineTo(x1+1, y2-1);

	pDC->SelectObject(&PenBlack);
	pDC->MoveTo(x1, y1);
	pDC->LineTo(x2, y1);
	pDC->LineTo(x2, y2);
	pDC->LineTo(x1, y2);
	pDC->LineTo(x1, y1);

	pDC->SelectObject(pOldPen);
	PenBlack.DeleteObject();
	PenWhite.DeleteObject();
	PenDarkGray.DeleteObject();
}

void CDrawTools::DrawPopBoxSmall(CDC *pDC,RECT Rect,long Color)
{
	DrawPopBoxSmall(pDC, Rect.left, Rect.top, Rect.right, Rect.bottom, Color);
}

void CDrawTools::DrawPopBoxSmall(CWnd *pWnd, int nSx, int nSy, int nEx, int nEy, long Color)
{
	CClientDC dc(pWnd);

	DrawPopBoxSmall(&dc, nSx, nSy, nEx, nEy, Color);
}

void CDrawTools::DrawPopBoxSmall(CWnd *pWnd, RECT Rect, long Color)
{
	CClientDC dc(pWnd);

	DrawPopBoxSmall(&dc, Rect, Color);
}


void CDrawTools::DrawPushBox(CDC *pDC, int x1, int y1, int x2, int y2, long color)
{
	CPen PenBlack, PenWhite, PenDarkGray, *pOldPen;

	DrawRect(pDC, x1+1, y1+1, x2-1, y2-1, color,color);

	//Draw PushBox Frame
	PenBlack.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	PenWhite.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	PenDarkGray.CreatePen(PS_SOLID, 1, RGB(127, 127, 127));

	pOldPen = (CPen*)pDC->SelectObject(&PenDarkGray);
	pDC->MoveTo(x1, y2);
	pDC->LineTo(x1, y1);
	pDC->LineTo(x2, y1);

	pDC->SelectObject(&PenWhite);
	pDC->LineTo(x2, y2);
	pDC->LineTo(x1, y2);

	pDC->SelectObject(&PenDarkGray);
	pDC->MoveTo(x1+1, y2-1);
	pDC->LineTo(x1+1, y1+1);
	pDC->LineTo(x2-1, y1+1);

	pDC->SelectObject(&PenWhite);

	pDC->LineTo(x2-1, y2-1);
	pDC->LineTo(x1+1, y2-1);

	pDC->SelectObject(&PenBlack);
	pDC->MoveTo(x1+2, y1+2);
	pDC->LineTo(x2-2, y1+2);
	pDC->LineTo(x2-2, y2-2);
	pDC->LineTo(x1+2, y2-2);
	pDC->LineTo(x1+2, y1+2);

	pDC->SelectObject(pOldPen);
	PenBlack.DeleteObject();
	PenWhite.DeleteObject();
	PenDarkGray.DeleteObject();
}

void CDrawTools::DrawPushBox(CDC *pDC,RECT Rect,long Color)
{
	DrawPushBox(pDC, Rect.left, Rect.top, Rect.right, Rect.bottom, Color);
}

void CDrawTools::DrawPushBox(CWnd *pWnd, int nSx, int nSy, int nEx, int nEy, long Color)
{
	CClientDC dc(pWnd);

	DrawPushBox(&dc, nSx, nSy, nEx, nEy, Color);
}

void CDrawTools::DrawPushBox(CWnd *pWnd, RECT Rect, long Color)
{
	CClientDC dc(pWnd);

	DrawPushBox(&dc, Rect, Color);
}



void CDrawTools::DrawPushBoxSmall(CDC *pDC, int x1, int y1, int x2, int y2, long color)
{
	CPen PenBlack, PenWhite, PenDarkGray, *pOldPen;

	DrawRect(pDC, x1+1, y1+1, x2-1, y2-1, color,color);

	//Draw PushBox Frame
	PenBlack.CreatePen(PS_SOLID, 1, RGB(0, 0, 0));
	PenWhite.CreatePen(PS_SOLID, 1, RGB(255, 255, 255));
	PenDarkGray.CreatePen(PS_SOLID, 1, RGB(127, 127, 127));

	pOldPen = (CPen*)pDC->SelectObject(&PenDarkGray);
	pDC->MoveTo(x1, y2);
	pDC->LineTo(x1, y1);
	pDC->LineTo(x2, y1);

	pDC->SelectObject(&PenWhite);
	pDC->LineTo(x2, y2);
	pDC->LineTo(x1, y2);

	pDC->SelectObject(&PenBlack);
	pDC->MoveTo(x1+1, y1+1);
	pDC->LineTo(x2-1, y1+1);
	pDC->LineTo(x2-1, y2-1);
	pDC->LineTo(x1+1, y2-1);
	pDC->LineTo(x1+1, y1+1);

	pDC->SelectObject(pOldPen);
	PenBlack.DeleteObject();
	PenWhite.DeleteObject();
	PenDarkGray.DeleteObject();
}


void CDrawTools::DrawPushBoxSmall(CDC *pDC,RECT Rect,long Color)
{
	DrawPushBox(pDC, Rect.left, Rect.top, Rect.right, Rect.bottom, Color);
}

void CDrawTools::DrawPushBoxSmall(CWnd *pWnd, int nSx, int nSy, int nEx, int nEy, long Color)
{
	CClientDC dc(pWnd);

	DrawPushBoxSmall(&dc, nSx, nSy, nEx, nEy, Color);
}

void CDrawTools::DrawPushBoxSmall(CWnd *pWnd, RECT Rect, long Color)
{
	CClientDC dc(pWnd);

	DrawPushBoxSmall(&dc, Rect, Color);
}

