#if !defined(__DRAWTOOLS_H)
#define __DRAWTOOLS_H

#define TYPE_TOP_POINT		0
#define TYPE_BOTTOM_POINT	1
#define TYPE_LEFT_POINT		2
#define TYPE_RIGHT_POINT	3

class CDrawTools
{
	private:
		int m_LineThick;

	public:
		CDrawTools();
		~CDrawTools();

		void SetLineThick(int LineThick);
		void DrawLine(CDC *pDC,int nSx,int nSy,int nEx,int nEy,COLORREF nColor);
		void DrawLine(CDC *pDC,RECT Rect,COLORREF Color);
		void DrawLine(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,COLORREF nColor);
		void DrawLine(CWnd *pWnd,RECT Rect,COLORREF Color);
		void DrawRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color);
		void DrawRect(CDC *pDC,RECT Rect,long Color);
		void DrawRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color);
		void DrawRect(CWnd *pWnd,RECT Rect,long Color);
		void DrawRect(HDC hdc,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2);
		void DrawRect(HDC hdc,RECT Rect,long Color1,long Color2);
		void DrawRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2);
		void DrawRect(CDC *pDC,RECT Rect,long Color1,long Color2);
		void DrawRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2);
		void DrawRect(CWnd *pWnd,RECT Rect,long Color1,long Color2);
		void DrawEllipse(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color);
		void DrawEllipse(CDC *pDC,RECT Rect,long Color);
		void DrawEllipse(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color);
		void DrawEllipse(CWnd *pWnd,RECT Rect,long Color);
		void DrawEllipse(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2);
		void DrawEllipse(CDC *pDC,RECT Rect,long Color,long Color2);
		void DrawEllipse(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color,long Color2);
		void DrawEllipse(CWnd *pWnd,RECT Rect,long Color,long Color2);
		void DrawRoundRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color);
		void DrawRoundRect(CDC *pDC,RECT Rect,long Color);
		void DrawRoundRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color);
		void DrawRoundRect(CWnd *pWnd,RECT Rect,long Color);
		void DrawRoundRect(CDC *pDC,int nSx,int nSy,int nEx,int nEy,long Color1,long Color2);
		void DrawRoundRect(CDC *pDC,RECT Rect,long Color,long Color2);
		void DrawRoundRect(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy,long Color,long Color2);
		void DrawRoundRect(CWnd *pWnd,RECT Rect,long Color,long Color2);
		void DrawPolygon(CDC *pDC, POINT *pPoints, int nCount, long Color1,long Color2);
		void DrawTriangle(CDC *pDC, RECT Rect, int nType, long Color1, long Color2);
		void DrawRectXor(CWnd *pWnd,RECT Rect);
		void DrawRectXor(CWnd *pWnd,int nSx,int nSy,int nEx,int nEy);
		void DrawPopBox(HDC hdc, int x1, int y1, int x2, int y2, long color);
		void DrawPopBox(HDC hdc, RECT Rect, long Color);
		void DrawPopBox(CDC *pDC, int x1, int y1, int x2, int y2, long color);
		void DrawPopBox(CDC *pDC, RECT Rect, long Color);
		void DrawPopBox(CWnd *pWnd, int x1, int y1, int x2, int y2, long color);
		void DrawPopBox(CWnd *pWnd, RECT Rect, long Color);
		void DrawPopBoxSmall(CDC *pDC, int x1, int y1, int x2, int y2, long color);
		void DrawPopBoxSmall(CDC *pDC, RECT Rect, long Color);
		void DrawPopBoxSmall(CWnd *pWnd, int x1, int y1, int x2, int y2, long color);
		void DrawPopBoxSmall(CWnd *pWnd, RECT Rect, long Color);
		void DrawPushBox(CDC *pDC, int x1, int y1, int x2, int y2, long color);
		void DrawPushBox(CDC *pDC, RECT Rect, long Color);
		void DrawPushBox(CWnd *pWnd, int x1, int y1, int x2, int y2, long color);
		void DrawPushBox(CWnd *pWnd, RECT Rect, long Color);
		void DrawPushBoxSmall(CDC *pDC, int x1, int y1, int x2, int y2, long color);
		void DrawPushBoxSmall(CDC *pDC, RECT Rect, long Color);
		void DrawPushBoxSmall(CWnd *pWnd, int x1, int y1, int x2, int y2, long color);
		void DrawPushBoxSmall(CWnd *pWnd, RECT Rect, long Color);
};

#endif