// TetrisCtl.cpp : Implementation of the CTetrisCtrl ActiveX Control class.

#include "stdafx.h"
#include "Tetris.h"
#include "TetrisCtl.h"
#include "TetrisPpg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CTetrisCtrl, COleControl)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CTetrisCtrl, COleControl)
	//{{AFX_MSG_MAP(CTetrisCtrl)
	ON_WM_KEYDOWN()
	ON_WM_TIMER()
	ON_WM_LBUTTONDOWN()
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CTetrisCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CTetrisCtrl)
	DISP_FUNCTION(CTetrisCtrl, "LeftMove", LeftMove, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "RightMove", RightMove, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "ChangeShape", ChangeShape, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "DownMove", DownMove, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "BottomMove", BottomMove, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "StartTetris", StartTetris, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "StopTetris", StopTetris, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "PauseTetris", PauseTetris, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CTetrisCtrl, "ChangeLevel", ChangeLevel, VT_EMPTY, VTS_I2)
	DISP_FUNCTION(CTetrisCtrl, "GetRemainedCount", GetRemainedCount, VT_I2, VTS_NONE)
	//}}AFX_DISPATCH_MAP
	DISP_FUNCTION_ID(CTetrisCtrl, "AboutBox", DISPID_ABOUTBOX, AboutBox, VT_EMPTY, VTS_NONE)
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CTetrisCtrl, COleControl)
	//{{AFX_EVENT_MAP(CTetrisCtrl)
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CTetrisCtrl, 1)
	PROPPAGEID(CTetrisPropPage::guid)
END_PROPPAGEIDS(CTetrisCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CTetrisCtrl, "TETRIS.TetrisCtrl.1",
	0x2f0d6743, 0x3f5c, 0x4039, 0x84, 0x92, 0x6e, 0xb, 0x35, 0x90, 0xe3, 0xe1)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CTetrisCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DTetris =
		{ 0x399d0558, 0xe927, 0x4e53, { 0x80, 0xb4, 0xbb, 0x1e, 0xb0, 0xc0, 0x61, 0xf8 } };
const IID BASED_CODE IID_DTetrisEvents =
		{ 0x3f995306, 0x7731, 0x41a9, { 0xbc, 0x7c, 0xe6, 0x1e, 0xf8, 0xc4, 0x88, 0x76 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwTetrisOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CTetrisCtrl, IDS_TETRIS, _dwTetrisOleMisc)


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::CTetrisCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CTetrisCtrl

BOOL CTetrisCtrl::CTetrisCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegApartmentThreading to 0.

	if (bRegister){
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_TETRIS,
			IDB_TETRIS,
			afxRegApartmentThreading,
			_dwTetrisOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	}
	else
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
}


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::CTetrisCtrl - Constructor

CTetrisCtrl::CTetrisCtrl()
{
	InitializeIIDs(&IID_DTetris, &IID_DTetrisEvents);

	m_bExecutingTetris = FALSE;
	m_nLevel = 0;
	InitMem();
}


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::~CTetrisCtrl - Destructor

CTetrisCtrl::~CTetrisCtrl()
{
	// TODO: Cleanup your control's instance data here.
}

void CTetrisCtrl::InitMem()
{
	m_pointUnit.x = HORZ_MATRIX_COUNT / 2 - 2;
	m_pointUnit.y = 0 ;
	m_nNextKind = rand() % 7;
	m_nKind = rand() % 7;
	m_nShape = 0;
	m_bStartedProgram = FALSE;
	memset(m_TetrisMem, 0, VERT_MATRIX_COUNT*HORZ_MATRIX_COUNT);
	for(int i = 0; i < HORZ_MATRIX_COUNT; i++){
		for(int j = 0; j < VERT_MATRIX_COUNT; j++){
/*			if(i < HORZ_MATRIX_COUNT/2 - 2 && i > HORZ_MATRIX_COUNT/2 + 2){
				m_TetrisMem[0][i] = 15;
			}
*/			m_TetrisMem[VERT_MATRIX_COUNT-1][i] = 15;
			m_TetrisMem[j][0] = 15;
			m_TetrisMem[j][HORZ_MATRIX_COUNT-1] = 15;
		}
	}
	m_bTimerFlag = FALSE;
	m_nRemoveCount = 0;
	m_Text.SetBkMode(OPAQUE);
}
/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::OnDraw - Drawing function

void CTetrisCtrl::OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	static COLORREF PureVGAColorsArray[20] = {
		RGB(0,0,0),         // Black
		RGB(0,0,255),       // Bright blue
		RGB(0,255,0),       // Bright green
		RGB(0,255,255),     // Cyan
		RGB(255,0,0),       // Bright red
		RGB(255,0,255),     // Magenta
		RGB(255,255,0),     // Bright yellow
		RGB(255,255,255),   // White
		RGB(0,0,128),       // Dark blue
		RGB(0,128,0),       // Dark green
		RGB(0,128,128),     // Blue-green
		RGB(128,0,0),       // Brown
		RGB(128,0,128),     // Dark purple
		RGB(128,128,0),     // Olive
		RGB(128,128,128),   // Dark gray
		RGB(192,192,192),   // Light gray
		RGB(192,220,192),   // Pale green
		RGB(166,202,240),   // Light blue
		RGB(255,251,240),   // Off-white
		RGB(160,160,164),   // Medium gray
	};

	// TODO: Replace the following code with your own drawing code.
	if(!m_bStartedProgram){
		m_bStartedProgram = TRUE;
		m_BackImage.Create(this, (HORZ_MATRIX_COUNT-2)*UNIT_SIZE, (VERT_MATRIX_COUNT+3)*UNIT_SIZE);
		m_DrawTools.DrawRect(pdc, rcBounds, RGB(255, 255, 255), RGB(255, 255, 255));
		SetFocus();
		SetTimer(1000, 50, NULL);
	}
	CDC *pMemDC = m_BackImage.GetBitmapDC(pdc);
//	CDC *pMemDC = pdc;
	m_DrawTools.DrawRect(pMemDC, rcBounds, RGB(255, 255, 255), RGB(255, 255, 255));

	CString strBuffer;
	strBuffer.Format("%02d", LEVEL_CHANGE_COUNT-m_nRemoveCount);
	m_Text.DrawText(pMemDC, 20, 30, strBuffer, RGB(0, 0, 0));
	strBuffer.Format("Level%02d", m_nLevel+1);
	m_Text.DrawText(pMemDC, (HORZ_MATRIX_COUNT / 2 + 2)*UNIT_SIZE + 10, 30, strBuffer, RGB(0, 0, 0));

	CRect rectPos;
	for(int i = 1; i < HORZ_MATRIX_COUNT - 1; i++){
		for(int j = 0; j < VERT_MATRIX_COUNT-1; j++){
			rectPos = CRect(HORZ_DRAW_START_POS + (i-1)*UNIT_SIZE, VERT_DRAW_START_POS + j*UNIT_SIZE, 
						HORZ_DRAW_START_POS + i*UNIT_SIZE, VERT_DRAW_START_POS + (j+1)*UNIT_SIZE);
			if(m_TetrisMem[j][i])
				m_DrawTools.DrawPopBoxSmall(pMemDC, rectPos, PureVGAColorsArray[m_TetrisMem[j][i]]);
			else
				m_DrawTools.DrawRect(pMemDC, rectPos, RGB(0, 0, 0), RGB(0, 0, 0));
		}
	}
	BYTE pData[4][4];
//	if(m_bExecutingTetris){	// ð ǥ
		GetTetrisData(m_nNextKind, 0, (BYTE*)pData);

		for(i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				rectPos = CRect(HORZ_DRAW_START_POS + (i+HORZ_MATRIX_COUNT / 2 - 3)*UNIT_SIZE, j*UNIT_SIZE, 
								HORZ_DRAW_START_POS + (i+HORZ_MATRIX_COUNT / 2 - 2)*UNIT_SIZE, (j+1)*UNIT_SIZE);
				if(pData[j][i])
					m_DrawTools.DrawPopBoxSmall(pMemDC, rectPos, PureVGAColorsArray[pData[j][i]]);
				else
					m_DrawTools.DrawRect(pMemDC, rectPos, RGB(255, 255, 255), RGB(255, 255, 255));
			}
		}
//	}

	if(m_bExecutingTetris){ //  Ȳ ǥ
		GetTetrisData(m_nKind, m_nShape, (BYTE*)pData);

		for(i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if(pData[j][i]){
					rectPos = CRect(HORZ_DRAW_START_POS + (i+m_pointUnit.x-1)*UNIT_SIZE, VERT_DRAW_START_POS + (j+m_pointUnit.y)*UNIT_SIZE, 
								HORZ_DRAW_START_POS + (i+m_pointUnit.x)*UNIT_SIZE, VERT_DRAW_START_POS + (j+m_pointUnit.y+1)*UNIT_SIZE);
					m_DrawTools.DrawPopBoxSmall(pMemDC, rectPos, PureVGAColorsArray[pData[j][i]]);
				}
			}
		}
	}
	
	m_BackImage.ReleaseBitmapDC();
	m_BackImage.Draw(pdc);
}


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::DoPropExchange - Persistence support

void CTetrisCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	// TODO: Call PX_ functions for each persistent custom property.

}


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::OnResetState - Reset control to default state

void CTetrisCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

	// TODO: Reset any other control state here.
}


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl::AboutBox - Display an "About" box to the user

void CTetrisCtrl::AboutBox()
{
	CDialog dlgAbout(IDD_ABOUTBOX_TETRIS);
	dlgAbout.DoModal();
}


/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl message handlers
void CTetrisCtrl::GetTetrisData(int nKind, int nShape, BYTE *pData)
{
	static BYTE TetrisUnit[7][4][16]={
		{{0,0,0,0,3,3,3,0,0,3,0,0,0,0,0,0},
		{0,3,0,0,0,3,3,0,0,3,0,0,0,0,0,0},
		{0,3,0,0,3,3,3,0,0,0,0,0,0,0,0,0},
		{0,3,0,0,3,3,0,0,0,3,0,0,0,0,0,0}},

		{{0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0},
		{0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0},
		{0,0,0,0,4,4,4,4,0,0,0,0,0,0,0,0},
		{0,0,4,0,0,0,4,0,0,0,4,0,0,0,4,0}},

		{{0,0,0,0,1,1,1,0,1,0,0,0,0,0,0,0},
		{0,1,0,0,0,1,0,0,0,1,1,0,0,0,0,0},
		{0,0,1,0,1,1,1,0,0,0,0,0,0,0,0,0},
		{1,1,0,0,0,1,0,0,0,1,0,0,0,0,0,0}},

		{{0,0,0,0,6,6,6,0,0,0,6,0,0,0,0,0},
		{0,6,6,0,0,6,0,0,0,6,0,0,0,0,0,0},
		{6,0,0,0,6,6,6,0,0,0,0,0,0,0,0,0},
		{0,6,0,0,0,6,0,0,6,6,0,0,0,0,0,0}},

		{{0,0,0,0,14,14,0,0,14,14,0,0,0,0,0,0},
		{0,0,0,0,14,14,0,0,14,14,0,0,0,0,0,0},
		{0,0,0,0,14,14,0,0,14,14,0,0,0,0,0,0},
		{0,0,0,0,14,14,0,0,14,14,0,0,0,0,0,0}},

		{{0,0,0,0,5,5,0,0,0,5,5,0,0,0,0,0},
		{0,0,0,0,0,5,0,0,5,5,0,0,5,0,0,0},
		{0,0,0,0,5,5,0,0,0,5,5,0,0,0,0,0},
		{0,0,0,0,0,5,0,0,5,5,0,0,5,0,0,0}},

		{{0,0,0,0,0,2,2,0,2,2,0,0,0,0,0,0},
		{0,0,0,0,2,0,0,0,2,2,0,0,0,2,0,0},
		{0,0,0,0,0,2,2,0,2,2,0,0,0,0,0,0},
		{0,0,0,0,2,0,0,0,2,2,0,0,0,2,0,0}}
	};

	memcpy(pData, TetrisUnit[nKind][nShape], 16);
}

BOOL CTetrisCtrl::CheckEnableMove(POINT point, int nShape)
{
	BYTE pData[4][4];

	GetTetrisData(m_nKind, nShape, (BYTE *)pData);

	for(int i = 0; i < 4; i++){
		for(int j = 0; j < 4; j++){
			if(point.x + i>=HORZ_MATRIX_COUNT || point.y + j>=VERT_MATRIX_COUNT)
				continue;
			if(m_TetrisMem[point.y + j][point.x + i] && pData[j][i]){
				return FALSE;
			}
		}
	}
	return TRUE;
}

void CTetrisCtrl::CheckRemove()
{
	BOOL bChecked;
	for(int i = 0; i < VERT_MATRIX_COUNT-1; i++){
		bChecked = TRUE;
		for(int j = 1; j < HORZ_MATRIX_COUNT-1; j++){
			if(!m_TetrisMem[i][j]){
				bChecked = FALSE;
				break;
			}
		}
		if(bChecked){
			if(i<=0)
				continue;

			for(int y = i; y > 0; y--){
				for(int x = 1; x < HORZ_MATRIX_COUNT-1; x++){
					m_TetrisMem[y][x] = m_TetrisMem[y-1][x];
				}
			}
//			memcpy(m_TetrisMem[i], &m_TetrisMem[i-1], i * HORZ_MATRIX_COUNT);
			memset(&m_TetrisMem[0][1], 0, HORZ_MATRIX_COUNT - 2);
			m_nRemoveCount++;
			if(m_nRemoveCount>=LEVEL_CHANGE_COUNT){
				m_nLevel++;
				m_nLevel= min(10, m_nLevel);
				m_nRemoveCount = 0;
			}
		}
	}
}

void CTetrisCtrl::StopUnit(POINT point)
{
	BYTE pData[4][4];

	GetTetrisData(m_nKind, m_nShape, (BYTE *)pData);

	for(int i = 0; i < 4; i++){
		for(int j = 0; j < 4; j++){
			if(point.x + i>=HORZ_MATRIX_COUNT || point.y + j>=VERT_MATRIX_COUNT)
				continue;
			if(pData[j][i])
				m_TetrisMem[point.y + j][point.x + i] = pData[j][i];
		}
	}
	if(point.y != 0){
		CheckRemove();

		m_pointUnit.x = HORZ_MATRIX_COUNT / 2 - 2;
		m_pointUnit.y = 0 ;
		m_nKind = m_nNextKind;
		m_nNextKind = rand() % 7;
		m_nShape = 0;
		InvalidateControl();
	}
	else{
		m_bExecutingTetris = FALSE;
		m_bTimerFlag = FALSE;
		AfxMessageBox("GAME OVER");
	}
}

void CTetrisCtrl::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	if(nChar==VK_LEFT){
		m_pointUnit.x--;
		InvalidateControl();
	}
	COleControl::OnKeyDown(nChar, nRepCnt, nFlags);
}

void CTetrisCtrl::OnKeyDownEvent(USHORT nChar, USHORT nShiftState) 
{
	if(nChar==VK_LEFT){
		m_pointUnit.x--;
		InvalidateControl();
	}
	
	COleControl::OnKeyDownEvent(nChar, nShiftState);
}

void CTetrisCtrl::OnTimer(UINT nIDEvent) 
{
	static int nCount = 0;
	nCount++;
	if(nCount>10-m_nLevel){
		DownMove();
		nCount = 0;
	}
	COleControl::OnTimer(nIDEvent);
}

void CTetrisCtrl::LeftMove() 
{
	if(!m_bTimerFlag)
		return;

	POINT point;

	point.x = m_pointUnit.x-1;	
	point.y = m_pointUnit.y;	

	if(CheckEnableMove(point, m_nShape)){
		m_pointUnit.x = point.x;	
		m_pointUnit.y = point.y;
		InvalidateControl();
	}
}

void CTetrisCtrl::RightMove() 
{
	if(!m_bTimerFlag)
		return;

	POINT point;

	point.x = m_pointUnit.x+1;	
	point.y = m_pointUnit.y;	

	if(CheckEnableMove(point, m_nShape)){
		m_pointUnit.x = point.x;	
		m_pointUnit.y = point.y;
		InvalidateControl();
	}
}

void CTetrisCtrl::ChangeShape() 
{
	if(!m_bTimerFlag)
		return;

	int nShape = (m_nShape + 1) % 4;
	if(CheckEnableMove(m_pointUnit, nShape)){
		m_nShape = nShape;
		InvalidateControl();
	}
}

void CTetrisCtrl::DownMove() 
{
	if(!m_bTimerFlag)
		return;

	POINT point;

	point.x = m_pointUnit.x;	
	point.y = m_pointUnit.y+1;	

	if(CheckEnableMove(point, m_nShape)){
		m_pointUnit.x = point.x;	
		m_pointUnit.y = point.y;
		InvalidateControl();
	}
	else{
		StopUnit(m_pointUnit);
		InvalidateControl();
	}
}

void CTetrisCtrl::BottomMove() 
{
	if(!m_bTimerFlag)
		return;

	POINT point;

	point.x = m_pointUnit.x;	
	point.y = m_pointUnit.y;

	while(1){
		point.y++;
		if(CheckEnableMove(point, m_nShape)){
			m_pointUnit.x = point.x;	
			m_pointUnit.y = point.y;
		}
		else{
			StopUnit(m_pointUnit);
			InvalidateControl();
			break;
		}
	}
}

void CTetrisCtrl::OnKeyPressEvent(USHORT nChar) 
{
	
	COleControl::OnKeyPressEvent(nChar);
}

void CTetrisCtrl::OnLButtonDown(UINT nFlags, CPoint point) 
{
	SetFocus();	
	COleControl::OnLButtonDown(nFlags, point);
}

void CTetrisCtrl::StartTetris() 
{
	if(!m_bExecutingTetris)
		InitMem();

	m_bExecutingTetris = TRUE;
	m_bTimerFlag = TRUE;
	SetFocus();
}

void CTetrisCtrl::StopTetris() 
{
	m_bExecutingTetris = FALSE;
	InitMem();
	InvalidateControl();
}

void CTetrisCtrl::PauseTetris() 
{
	m_bTimerFlag = FALSE;
}

void CTetrisCtrl::ChangeLevel(short nLevel) 
{
	if(m_nLevel == nLevel)
		return;

	m_nLevel = nLevel;
}

short CTetrisCtrl::GetRemainedCount() 
{
	return LEVEL_CHANGE_COUNT-m_nRemoveCount;
}
