#if !defined(AFX_TETRISCTL_H__46C512A2_45D7_4BFD_BF79_48A639E37F38__INCLUDED_)
#define AFX_TETRISCTL_H__46C512A2_45D7_4BFD_BF79_48A639E37F38__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// TetrisCtl.h : Declaration of the CTetrisCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CTetrisCtrl : See TetrisCtl.cpp for implementation.
#include "DrawTools.h"
#include "BackImage.h"
#include "Text.h"
#include <atlctl.h>

#define HORZ_MATRIX_COUNT	16
#define VERT_MATRIX_COUNT	26
#define UNIT_SIZE			16
#define HORZ_DRAW_START_POS	0
#define VERT_DRAW_START_POS	(UNIT_SIZE*4)

#define LEVEL_CHANGE_COUNT	10

class CTetrisCtrl : public COleControl
{
	DECLARE_DYNCREATE(CTetrisCtrl)

// Constructor
public:
	CTetrisCtrl();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTetrisCtrl)
	public:
	virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
	virtual void DoPropExchange(CPropExchange* pPX);
	virtual void OnResetState();
	virtual void OnKeyDownEvent(USHORT nChar, USHORT nShiftState);
	virtual void OnKeyPressEvent(USHORT nChar);
	//}}AFX_VIRTUAL
	POINT m_pointUnit;
	int m_nNextKind;
	int m_nKind;
	int m_nShape;
	BYTE m_TetrisMem[VERT_MATRIX_COUNT][HORZ_MATRIX_COUNT];
	CDrawTools m_DrawTools;
	CBackImage m_BackImage;
	CText m_Text;
	BOOL m_bStartedProgram;
	BOOL m_bExecutingTetris;
	BOOL m_bTimerFlag;
	int m_nLevel;
	int m_nRemoveCount;
// Implementation
protected:
	~CTetrisCtrl();

	void GetTetrisData(int nKind, int nShape, BYTE *pData);
	BOOL CheckEnableMove(POINT point, int nShape);
	void StopUnit(POINT point);
	void InitMem();
	void CheckRemove();

	DECLARE_OLECREATE_EX(CTetrisCtrl)    // Class factory and guid
	DECLARE_OLETYPELIB(CTetrisCtrl)      // GetTypeInfo
	DECLARE_PROPPAGEIDS(CTetrisCtrl)     // Property page IDs
	DECLARE_OLECTLTYPE(CTetrisCtrl)		// Type name and misc status

// Message maps
	//{{AFX_MSG(CTetrisCtrl)
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

// Dispatch maps
	//{{AFX_DISPATCH(CTetrisCtrl)
	afx_msg void LeftMove();
	afx_msg void RightMove();
	afx_msg void ChangeShape();
	afx_msg void DownMove();
	afx_msg void BottomMove();
	afx_msg void StartTetris();
	afx_msg void StopTetris();
	afx_msg void PauseTetris();
	afx_msg void ChangeLevel(short nLevel);
	afx_msg short GetRemainedCount();
	//}}AFX_DISPATCH
	DECLARE_DISPATCH_MAP()

	afx_msg void AboutBox();

// Event maps
	//{{AFX_EVENT(CTetrisCtrl)
	//}}AFX_EVENT
	DECLARE_EVENT_MAP()

// Dispatch and event IDs
public:
	enum {
	//{{AFX_DISP_ID(CTetrisCtrl)
	dispidLeftMove = 1L,
	dispidRightMove = 2L,
	dispidChangeShape = 3L,
	dispidDownMove = 4L,
	dispidBottomMove = 5L,
	dispidStartTetris = 6L,
	dispidStopTetris = 7L,
	dispidPauseTetris = 8L,
	dispidChangeLevel = 9L,
	dispidGetRemainedCount = 10L,
	//}}AFX_DISP_ID
	};
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TETRISCTL_H__46C512A2_45D7_4BFD_BF79_48A639E37F38__INCLUDED)
