#include "stdafx.h"

#include "Text.h"

CText::CText()
{
	m_nFormat = DT_CENTER | DT_VCENTER | DT_SINGLELINE;
	m_nBkMode = TRANSPARENT;

	m_LogFont.lfHeight = -13;
    m_LogFont.lfWidth = 0;
    m_LogFont.lfEscapement = 0;
    m_LogFont.lfOrientation = 0;
	m_LogFont.lfWeight = 400;
    m_LogFont.lfItalic = 0;
    m_LogFont.lfUnderline = 0;
    m_LogFont.lfStrikeOut = 0;
    m_LogFont.lfClipPrecision = 2;
    m_LogFont.lfPitchAndFamily = 34;
#ifdef __COMPILE_CHINA
	m_LogFont.lfCharSet = 134;
    m_LogFont.lfOutPrecision = 1;
	m_LogFont.lfQuality = 2;
    strcpy(m_LogFont.lfFaceName,  _T("")); 
#else
	m_LogFont.lfCharSet = 129;
    m_LogFont.lfOutPrecision = 3;
	m_LogFont.lfQuality = 1;
    strcpy(m_LogFont.lfFaceName,  _T("ü")); 
#endif
}

void CText::SetDrawFormat(UINT nFormat)
{
	m_nFormat = nFormat;
}

void CText::SetLogFont(LOGFONT LogFont)
{
	m_LogFont = LogFont;
}

void CText::GetLogFont(LOGFONT &LogFont)
{
	LogFont = m_LogFont;
}

CSize CText::DrawText(CDC* pDC, int x, int y, LPCTSTR strText, COLORREF Color, LOGFONT *pLogFont)
{
	CFont Font,*OldFont;

	if(pLogFont)
		Font.CreateFontIndirect(pLogFont);
	else
		Font.CreateFontIndirect(&m_LogFont);

	OldFont = pDC->SelectObject(&Font);

	pDC->SetBkMode(m_nBkMode);

	pDC->SetTextColor(Color);

	pDC->TextOut(x,y,strText,strlen(strText));

	CSize TextSize = pDC->GetTextExtent(strText, strlen(strText));

	pDC->SelectObject(OldFont);

	Font.DeleteObject();
	return TextSize;
}


CSize CText::DrawText(CDC *pDC, LPRECT pRect, LPCTSTR strText, COLORREF Color, LOGFONT* pLogFont, int nFormat)
{
	CFont Font,*OldFont;

	if(pLogFont)
		Font.CreateFontIndirect(pLogFont);
	else
		Font.CreateFontIndirect(&m_LogFont);

	OldFont = pDC->SelectObject(&Font);

	pDC->SetBkMode(m_nBkMode);

	pDC->SetTextColor(Color);

	if(nFormat<0)
		nFormat = m_nFormat;

	pDC->DrawText(strText,strlen(strText),pRect,nFormat);

	CSize TextSize = pDC->GetTextExtent(strText, strlen(strText));
	pDC->SelectObject(OldFont);

	Font.DeleteObject();
	return TextSize;
}

CSize CText::DrawText(HDC hdc, LPRECT pRect, LPCTSTR strText, COLORREF Color, LOGFONT* pLogFont, int nFormat)
{
	HFONT hFont, OldFont;

	if(pLogFont)
		hFont = ::CreateFontIndirect(pLogFont);
	else
		hFont = ::CreateFontIndirect(&m_LogFont);

	OldFont = (HFONT)SelectObject(hdc, hFont);

	::SetBkMode(hdc, m_nBkMode);

	SetTextColor(hdc, Color);

	if(nFormat<0)
		nFormat = m_nFormat;

	::DrawText(hdc, strText, strlen(strText), pRect, nFormat);

	TEXTMETRIC tm;
	CSize TextSize;
	GetTextMetrics(hdc,&tm);

	TextSize.cx = tm.tmAveCharWidth;
	TextSize.cy = tm.tmHeight+tm.tmExternalLeading;

	SelectObject(hdc, OldFont);

	DeleteObject(hFont);
	return TextSize;
}
